@ECHO OFF
REM CreateQMgr.bat                             CACI, Inc.    2014.01     G Brown
::
:: NOTE: This script normally should be invoked only by 'QM1_Create.bat'.
::
SETLOCAL ENABLEDELAYEDEXPANSION
::

SET "MQSCOPTS=/X %MQSCOPTS%"
SET LOGFILE=%QMGR%.CreateQMgr.log

ECHO %0          WMQ Queue Manager Creation Log File          %DATE% %TIME% > %LOGFILE%
ECHO. >> %LOGFILE%

:: Make sure WMQ is installed

dspmqinst > NUL

IF ERRORLEVEL 9009 (
  ECHO.
  ECHO It appears that WMQ is not installed on this host.
  ECHO If WMQ is installed be sure the WMQ bin directory is defined in the 'PATH' environment variable.
  ECHO.
  GOTO :EOF
)

:VerifyQMgr
:: Find where the WMQ binaries live

FOR /F "delims=" %%Z IN ('dspmqver -b -f 128') DO SET "WMQBIN=%%Z\bin"
ECHO.
ECHO Found WMQ bin directory: "%WMQBIN%"

ECHO. >> %LOGFILE%
ECHO Found WMQ bin Directory: "%WMQBIN%" >> %LOGFILE%

:: See if queue manager is defined

"%WMQBIN%\dspmq" -m %QMGR% 2>&1 | FIND "AMQ7048" > NUL

IF ERRORLEVEL 1 (
  ECHO.
  ECHO Queue Manager Already Exists: %QMGR%

  ECHO. >> %LOGFILE%
  ECHO Queue Manager Already Exists: %QMGR% >> %LOGFILE%
  GOTO :EOF
)

ECHO.
ECHO Creating Queue Manager: %QMGR%

ECHO. >> %LOGFILE%
ECHO Creating Queue Manager: %QMGR% >> %LOGFILE%

"%WMQBIN%\crtmqm" %CRTQMGARGS% %QMGR% >> %LOGFILE% 2>&1

IF ERRORLEVEL 1 GOTO :EOF

:: See if queue manager is running

"%WMQBIN%\dspmq" -m %QMGR% 2>&1 | FIND "Running" > NUL

IF ERRORLEVEL 1 (
  ECHO.
  ECHO Starting Queue Manager: %QMGR%

  ECHO. >> %LOGFILE%
  ECHO Starting Queue Manager: %QMGR% >> %LOGFILE%

  "%WMQBIN%\strmqm" %QMGR% >> %LOGFILE% 2>&1
)

:: Define queue manager objects

IF EXIST UpdateQMgr.bat (
  ECHO.
  ECHO Creating Objects for Queue Manager: %QMGR%

  ECHO. >> %LOGFILE%
  ECHO Creating Objects for Queue Manager: %QMGR% >> %LOGFILE%

  CALL UpdateQMgr.bat %MQSCOPTS% %QMGR%
) ELSE (
  ECHO.
  ECHO ERROR: File not found: UpdateQMgr.bat

  ECHO. >> %LOGFILE%
  ECHO ERROR: File not found: UpdateQMgr.bat >> %LOGFILE%
)

:EOF
